---
- name: Include OS specific setup tasks
  ansible.builtin.include_tasks: "{{ item }}"
  with_first_found:
    - "tasks/setup-{{ ansible_facts['distribution'] | lower }}.yml"
    - "tasks/setup-{{ ansible_facts['os_family'] | lower }}.yml"

- name: Enable docker service
  ansible.builtin.systemd_service:
    name: docker
    state: started
    enabled: true

- name: Ensure docker group exists
  ansible.builtin.group:
    name: docker
    state: present

- name: Ensure docker users are added to the docker group
  ansible.builtin.user:
    name: "{{ item }}"
    groups:
      - "docker"
    append: true
  with_items: "{{ docker_users }}"

- name: Ensure /etc/docker/ directory exists.
  ansible.builtin.file:
    path: /etc/docker
    state: directory
    mode: "0755"
  when: docker_daemon_options.keys() | length > 0

- name: Configure Docker daemon options.
  ansible.builtin.copy:
    content: "{{ docker_daemon_options | to_nice_json }}"
    dest: /etc/docker/daemon.json
    mode: "0644"
  when: docker_daemon_options.keys() | length > 0
  notify: Restart docker
